const xPosition = (d, i) => i * 120+60

export const colorLegend = (selection, props) => {
  const { 
    colorScale, 
    circleRadius,
    spacing,
    textOffset,
    backgroundRectWidth,
    onClick,
    selectedColorValue
  } = props;
  	
  const backgroundRect = selection.selectAll('rect')
  	.data([null]);
  backgroundRect.enter().append('rect')
  	.merge(backgroundRect)
  		.attr('x', -circleRadius*2)
  		.attr('y', -circleRadius*2)
  		.attr('rx', circleRadius*2)
  		.attr('width', backgroundRectWidth)
  		.attr('height', spacing * colorScale.domain().length + circleRadius*2)
  		.attr('fill', 'white')
  		.attr('opacity', 0.8)
  
  const groups = selection.selectAll('g').data(colorScale.domain());
 	const groupsEnter = groups.enter().append('g').attr('class', 'tick');
  groupsEnter
    .merge(groups)
  		.attr('transform', (d, i) => 
            `translate(0, ${i * spacing})`)
  		.attr('opacity',
            d => d === selectedColorValue || !selectedColorValue
           ? 1
           : 0.2)
  		.on('click', d => onClick(d === selectedColorValue
         ? null
         : d));
    
  groupsEnter.append('circle')
    .merge(groups.select('circle'))
  		.attr('fill', colorScale)
    	.attr('r',  circleRadius);
	
  groupsEnter.append('text')
    .merge(groups.select('text'))
  		.text(d => d)
      .attr('x', textOffset)
  		.attr('dy', '0.32em')
  
}