import {
  select,
  scaleOrdinal,
  schemeSpectral
} from 'd3';
import { loadAndProcessData } from './loadAndProcessData';
import { colorLegend } from './colorLegend';
import { coloroplethMap } from './coloroplethMap';
const svg = select('svg');
const width = +svg.attr('width');
const height = +svg.attr("height");
const colorplethMapG = svg.append('g');
const colorLegendG = svg.append('g')
	.attr('transform', `translate(50, 300)`);


let selectedColorValue;
let features;
const onClick = d => {
  selectedColorValue = d;
  render()
};

loadAndProcessData().then(countries => {
	features = countries.features;
  render();
});


const colorScale = scaleOrdinal();
// const colorValue = d => d.properties.economy
const colorValue = d => d.properties.income_grp

const render = () => {
	colorScale
    .domain(features.map(colorValue))
  	.domain(colorScale.domain().sort().reverse())
  	.range(schemeSpectral[colorScale.domain().length]);
  

  
  colorLegendG
		.call(colorLegend, {
      colorScale,
      circleRadius: 10,
      spacing: 30,
      textOffset: 15,
      backgroundRectWidth: 270,
      onClick,
      selectedColorValue
		});
  
	colorplethMapG
    .call(coloroplethMap, {
  		features,
  	  colorValue,
   		colorScale,
    	selectedColorValue
 	 })
}

